import PyTango
import os
import time
from bpm_constants import *
from datetime import datetime
import numpy as np
from read_position import *
from PyTango import DeviceProxy

##os.system("gedit /home/thomx-util01/alex/libera_commamde.txt")
##PyTango.Database().get_device_exported('/opt/libera/sbin/libera-ds libera-instrument1')



PyTango.ApiUtil.get_env_var("TANGO_HOST")

def initialise_bpm(bpm_name1, bpm_name2, bpm_name3, bpm_name4):
    bpm_list = []
    successive_error = 0
    while bpm_list == []:
        try:
            #print(successive_error)
            successive_error += 1
            #print("\n")      
            if not(bpm_name1 is None):
                bpm_list.append([bpm_name1,DeviceProxy("Maquette/diag/bpm1")])
            if not(bpm_name2 is None):
                bpm_list.append([bpm_name2,DeviceProxy("Maquette/diag/bpm2")])
            if not(bpm_name3 is None):
                bpm_list.append([bpm_name3,DeviceProxy("Maquette/diag/bpm3")])
            if not(bpm_name4 is None):
                bpm_list.append([bpm_name4,DeviceProxy("Maquette/diag/bpm4")])
            for bpm in bpm_list:
                bpm[1].Fans = 6000
                bpm[1].AdcLength = 50 
                bpm[1].SpEnable = True
                bpm[1].Kx = 14136
                bpm[1].Ky = 14136
                bpm[1].SpThreshold = 200
                bpm[1].SpNBefor = 1
                bpm[1].SpNAfter = 20
        except:
            print("error of initialise bpm")
            bpm_list = []
            if successive_error > 4:
                raise
    return(bpm_list)

        
bpm_list = [DeviceProxy("Maquette/diag/bpm1"), DeviceProxy("Maquette/diag/bpm2"), DeviceProxy("Maquette/diag/bpm3")] # global list that containe data for each used BPM
#, DeviceProxy("Maquette/diag/bpm4")]
#bpm_list[0].Fans = 2500
#print(bpm_list[0].get_attribute_list())  # give all the attribute of a bpm
#print(bpm_list[0].T2TrigCount) #give the trigger 
#print(bpm_list[1].AdcLength)

def read_all_bpm(bpm_list): 
    for bpm in bpm_list:
        print_value(bpm)


def bpm_boucle(boucle_number,bpm):
    for i in range(boucle_number):
        print_value(bpm)

        
def print_value(bpm):
    print("\n")
    print("Va: ", bpm.SpVa)
    print("Vb : ", bpm.SpVb)
    print("Vc : ", bpm.SpVc)
    print("Vd : ", bpm.SpVd)
    print("Sum : ", bpm.SpSum)
    print("X : ", bpm.SpX)
    print("Y : ", bpm.SpY)   


def read_libera(bpm):
    data_libera =  [bpm[1].T2TrigCount,bpm[1].SpVa,bpm[1].SpVb,bpm[1].SpVc,bpm[1].SpVd,bpm[1].SpSum,bpm[1].SpX,bpm[1].SpY,bpm[1].T2TrigCount]
    while data_libera[8] != data_libera[0]:
        print("error trigger")
        data_libera =  [bpm[1].T2TrigCount,bpm[1].SpVa,bpm[1].SpVb,bpm[1].SpVc,bpm[1].SpVd,bpm[1].SpSum,bpm[1].SpX,bpm[1].SpY,bpm[1].T2TrigCount]
    else:
        return(data_libera)

#print(read_libera([3.1415,bpm_list[0]]))
    
def read_libera_and_write_2D(x_motor_step ,y_motor_step , # position of motor in step
                             data_name_and_path,
                             bpm_number, 
                             bpm, #list that contain in 0 the name of the bpm, and in 1 the bpm davice on libera
                             list_of_data): # list of data what we will read
    data_libera = []
    successive_error = 0
    while data_libera == []:
        try:
            #print(successive_error)
            successive_error += 1
            #print("\n")
            data_libera = read_libera(bpm)
        except:
            print("error of read libera")
            data_libera = []
            if successive_error > 4:
                raise
    fichier = open(data_name_and_path, "a")
    for data in list_of_data:
        if data == "bpm_name" :
            fichier.write(bpm[0])
            fichier.write(' ')
        elif data == "bpm_number" :
            fichier.write(str(bpm_number))
            fichier.write(' ') 
        elif data == "x_motor_step" :
            fichier.write(str(x_motor_step))
            fichier.write(' ') 
        elif data == "x_motor_mm" :
            x_motor_mm = x_motor_step # will there isn't potentiometer, this value can't be read
            fichier.write(str(x_motor_mm))
            fichier.write(' ') 
        elif data == "y_motor_step" :
            fichier.write(str(y_motor_step))
            fichier.write(' ') 
        elif data == "y_motor_mm" :
            position = read_vertical_position()
            y_motor_mm = position[0] # it's the number of the output of the optical rules
            fichier.write(str(y_motor_mm))
            fichier.write(' ') 
        elif data == "Va" :
            fichier.write(str(data_libera[1]))
            fichier.write(' ') 
        elif data == "Vb" :
            fichier.write(str(data_libera[2]))
            fichier.write(' ') 
        elif data == "Vc" :
            fichier.write(str(data_libera[3]))
            fichier.write(' ') 
        elif data == "Vd" :
            fichier.write(str(data_libera[4]))
            fichier.write(' ') 
        elif data == "Sum" :
            fichier.write(str(data_libera[5]))
            fichier.write(' ') 
        elif data == "x_libera_mm" :
            fichier.write(str(data_libera[6]/1000.)) #libera give value un micrometer, converted in millimeter 
            fichier.write(' ') 
        elif data == "y_libera_mm" :
            fichier.write(str(data_libera[7]/1000.)) #libera give value un micrometer, we write value in mm 
            fichier.write(' ')
        else:
            print("unknow ask data named " + data)
            fichier.write("nan")
            fichier.write(' ')
    fichier.write('\n')
    fichier.close()


def acquisition_libera(x_motor_step, y_motor_step, #coordinate of motor in step
                       data_name_and_path, #name of the file in which you write data
                       statistic_number, # nuber of repetition of taking data whith 1 set of parameter
                       list_of_data, #list of the name of the data that the program will read
                       bpm_list): #list of the bpm on which you need to read data with look like [["bpm_name1",bpm_DeviceProxy1],["bpm_name2",bpm_DeviceProxy2],...]
    for i in range(statistic_number): #take a set of statistic_number times the data for one set of parameters
        for bpm_number in range(len(bpm_list)):
            read_libera_and_write_2D(x_motor_step, y_motor_step,data_name_and_path, bpm_number, bpm_list[bpm_number], list_of_data)

                                    
#print(acquisition_libera("test",3.1415))

# to get Kx : bpm.kx
# to write Kx : bpm.kx = 10000000
                                     
#x_motor_step = 3.1415
#y_motor_step = 0
#data_name_and_path = "blabla.txt"
#statistic_number = 1
#list_of_data = ["bpm_name","x_motor_step","x_motor_mm","y_motor_step","y_motor_mm","Va","Vb","Vc","Vd","Sum","x_libera_mm","y_libera_mm"]

#bpm_name1 = "BPM_E"
#bpm_name2 = "BPM_C"
#bpm_list = initialise_bpm(bpm_name1, None,bpm_name2,None)

#print(bpm_list)

#acquisition_libera(x_motor_step, y_motor_step, data_name_and_path, statistic_number, list_of_data, bpm_list)
